/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of Serpent.xs. Do not edit this file, edit Serpent.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Serpent.xs"
/*
    author: John Hughes (jhughes@frostburg.edu)
    date: 11/01

    I am indebted to Marc Lehmann, the author of the Crypt::Twofish2
    module, as I used his code as a guide.
*/

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "patchlevel.h"
#if (PATCHLEVEL == 4) || ((PATCHLEVEL == 5) && (SUBVERSION < 55))
static STRLEN nolen_na;
#define SvPV_nolen(sv) SvPV((sv), nolen_na)
#endif

#include "_serpent.c"

typedef struct cryptstate
{
    keyInstance ki;
    cipherInstance ci;
}* Crypt__Serpent;

#line 37 "Serpent.c"
XS(XS_Crypt__Serpent_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__Serpent_new)
{
    dXSARGS;
    if (items < 2 || items > 3)
	Perl_croak(aTHX_ "Usage: Crypt::Serpent::new(class, key, mode=MODE_ECB)");
    {
	SV*	class = ST(0);
	SV*	key = ST(1);
	unsigned char	mode;
	Crypt__Serpent	RETVAL;

	if (items < 3)
	    mode = MODE_ECB;
	else {
	    mode = (unsigned char)SvUV(ST(2));
	}
#line 46 "Serpent.xs"
    {
        STRLEN keySize;
        char str[65];

        if (! SvPOK(key))
            croak("Error: key must be a string scalar!");

        keySize = SvCUR(key);

        if (keySize != 16 && keySize != 24 && keySize != 32)
            croak("Error: key must be 16, 24, or 32 bytes in length.");

        Newz(0, RETVAL, 1, struct cryptstate);

        serpent_convert_to_string(keySize << 3, SvPV_nolen(key), str);

        if (makeKey(&RETVAL->ki, DIR_ENCRYPT, keySize << 3, str) != TRUE)
            croak("Error: makeKey failed.");
        if (cipherInit(&RETVAL->ci, mode, 0) != TRUE)
            croak("Error: cipherInit failed.");
    }         
#line 77 "Serpent.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::Serpent", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Crypt__Serpent_encrypt); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__Serpent_encrypt)
{
    dXSARGS;
    dXSI32;
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(self, data)", GvNAME(CvGV(cv)));
    {
	Crypt__Serpent	self;
	SV*	data = ST(1);
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::Serpent")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Serpent,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::Serpent");
#line 78 "Serpent.xs"
    {
        STRLEN size;
        void* rawbytes = SvPV(data, size);

        if (size != 16)
        {
            croak("Error: block size must be 16 bytes.");
            RETVAL = newSVpv("", 0);
        }
        else
        {
            RETVAL = NEWSV(0, size);
            SvPOK_only(RETVAL);
            SvCUR_set(RETVAL, size);

            (ix ? blockDecrypt : blockEncrypt)
                (&self->ci, &self->ki, rawbytes, size << 3, (void*)SvPV_nolen(RETVAL));
        }
    }
#line 122 "Serpent.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_Crypt__Serpent_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__Serpent_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Crypt::Serpent::DESTROY(self)");
    {
	Crypt__Serpent	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Serpent,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not a reference");
#line 104 "Serpent.xs"
        Safefree(self);
#line 146 "Serpent.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Crypt__Serpent); /* prototype to pass -Wmissing-prototypes */
XS(boot_Crypt__Serpent)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        newXSproto("Crypt::Serpent::new", XS_Crypt__Serpent_new, file, "$$;$");
        cv = newXS("Crypt::Serpent::encrypt", XS_Crypt__Serpent_encrypt, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$$") ;
        cv = newXS("Crypt::Serpent::decrypt", XS_Crypt__Serpent_encrypt, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$$") ;
        newXSproto("Crypt::Serpent::DESTROY", XS_Crypt__Serpent_DESTROY, file, "$");
    }

    /* Initialisation Section */

#line 32 "Serpent.xs"
{
	HV* stash = gv_stashpv("Crypt::Serpent", 0);

	newCONSTSUB(stash, "keysize", newSViv(32));
	newCONSTSUB(stash, "blocksize", newSViv(16));
}

#line 185 "Serpent.c"

    /* End of Initialisation Section */

    XSRETURN_YES;
}

